/**
 * Created by Webmaster on 17.07.2014.
 */

var fullData = {};

// This class is getting data from JSON
function GetData(param) {
//    console.log("param - ", param);
    var currArr = this;

    // Get main path of users data from server with JSON
    $.getJSON('./js/data' + param + '.json', function(data, status) {
        if(status == "success") {
            currArr.arr = data;
//            console.log("fullData.arr - ", fullData.arr);
//            $.each(data, function(index, value) {
//                console.log("index - ", index);
//                console.log("value - ", value);
                initialize(data);
//            })
        }
    });
}

function initialize(param) {
//    console.log("param - ", param);
//    console.log("fullData.marker - ", fullData.marker);
    /*
    *
     address1:"Strindbergsvej 1",
     andelsboligAnvendelsesUdgifter:1958,
     andelsboligBoligYdelse:1029,
     broker: {
         brokerId="069",
         brokerName="Holm & Hauberg BoligCenter Valby/København SV"
     },
     brokerChain:"DanBolig",
     brokerChainId:"1",
     brokerChainName:"",
     brutto:35968,
     builtYear:1915,
     county: {
         countyId=1084,
         name="Region Hovedstaden"
     },
     energyClassification:" ",
     externalPropertyImageUrl:null,
     externalPropertyUrl:null,
     hasOpenHouseCurrently:false,
     isSwapProperty:false,
     latLon:{
         lat=55.660058,
         lon=12.521015
     },
     netto:29633,
     openHouseDisplayText:"",
     placeName:" ",
     price:6500000,
     pricePerM2;36516,
     propertyId:"KF691509",
     propertySizeAdvertized:178,
     propertyType:{
         propertyTypeId=1,
         name="Villa"
     },
     name:"Villa",
     propertyTypeId:1,
     salesMethod:"G",
     spotText:"",
     totalNumberOfRooms:6,
     zipCode: {
         zipCodeId=2500,
         name="Valby"
     }
*/

    // Create an array of styles.
    var styles = [
        {
            "featureType": "road",
            "elementType": "geometry",
            "stylers": [
                {"hue": "#ff0000" },
                { "saturation": -100 },
                { "lightness": 49 },
                { "color": "#ffffff" }
            ]
        },
        {
            "featureType": "landscape",
            "elementType": "geometry.fill",
            "stylers": [
                { "color": "#e9e5dc" }
            ]
        },
        {
            "featureType": "water",
            "stylers": [
                { "color": "#9bbefe" }
            ]
        }
    ];

//    var image = {
//        url: 'images/marker.png',
//        // This marker is 20 pixels wide by 32 pixels tall.
//        size: new google.maps.Size(46, 65),
//        // The origin for this image is 0,0.
//        origin: new google.maps.Point(0,0),
//        // The anchor for this image is the base of the flagpole at 0,32.
//        anchor: new google.maps.Point(0, 65)
//    };


    // Create a new StyledMapType object, passing it the array of styles,
    // as well as the name to be displayed on the map type control.
    var styledMap = new google.maps.StyledMapType(styles,
        {name: "Styled Map"});
    var pointer = "";

    function calCenter(param) {
        var lat = 0;
        var lng = 0;
        var length = param.length - 1;

        $.each(param, function(index, value) {
            lat += value.latLon.lat;
            lng += value.latLon.lon;

            if(index == length) {

                lat = parseFloat(lat) / length;
                lng = parseFloat(lng) / length;
                pointer = {lat: parseInt(lat), lng: parseInt(lng)};
            }
        });
    }

    calCenter(param);

//    var myLatlng = new google.maps.LatLng(param.latLon.lat, param.latLon.lon);
    // center = {lat: -34, lng: 151}
    var myOptions = {
        zoom: 13,
        mapTypeId: google.maps.MapTypeId.ROADMAP,
        mapTypeControl: false,
        panControl: false,
        scaleControl: false,
        streetViewControl: false,
        zoomControl: true,
        zoomControlOptions: {
            style: google.maps.ZoomControlStyle.SMALL,
            position: google.maps.ControlPosition.LEFT_BOTTOM
        }
    };
    var map = new google.maps.Map(document.getElementById("map"), myOptions);

    //Associate the styled map with the MapTypeId and set it to display.
    map.mapTypes.set('map', styledMap);
    map.setMapTypeId('map');

    $.each(param, function(index, value) {
        var myLatlng = new google.maps.LatLng(value.latLon.lat, value.latLon.lon);

        var contentString = '<div id="content">';
        contentString += '<h2><strong>Addres: </strong>' + value.address1 + '</h2>';
        contentString += '<p><strong>Broker: </strong>' + value.broker.brokerName + '</p>';
        contentString += '<p><strong>BrokerChain: </strong>' + value.brokerChain + '</p>';
        contentString += '<p><strong>Brutto: </strong>' + value.brutto + '</p>';
        contentString += '<p><strong>BuiltYear: </strong>' + value.builtYear + '</p>';
        contentString += '<p><strong>County: </strong>' + value.county.name + '</p>';
        contentString += '<p><strong>Netto: </strong>' + value.netto + '</p>';
        contentString += '<p><strong>Price: </strong>' + value.price + '</p>';
        contentString += '<p><strong>Price per month: </strong>' + value.pricePerM2 + '</p>';
        contentString += '<p><strong>Type: </strong>' + value.propertyType.name + '</p>';
        contentString += '<p><strong>Name: </strong>' + value.name + '</p>';
        contentString += '<p><strong>Sales method: </strong>' + value.salesMethod + '</p>';
        contentString += '<p><strong>Total number of rooms: </strong>' + value.totalNumberOfRooms + '</p>';
        contentString += '<p><strong>zipCode: </strong>' + value.zipCode.name + '</p>';
        contentString += '</div><!-- content -->';

        var infowindow = new google.maps.InfoWindow({
            content: contentString
        });
        var marker = new google.maps.Marker({
            position: myLatlng,
            map: map,
            title: value.name
        });
        map.setCenter({lat: value.latLon.lat, lng: value.latLon.lon, noWrap:true});

        google.maps.event.addListener(marker, 'click', function() {
            if(fullData.prevInfoWindow) fullData.prevInfoWindow.close();
            fullData.prevInfoWindow = infowindow;
            infowindow.open(map,marker);
        });
    })


}

function templateHTML() {
    var content = "";

    if($(".printData").length == 0) content += '<div class="contentWrapper printData">';
    content += '<section>';
    content += '<div id="map"></div>';
    content += '</section>';
    if($(".printData").length == 0) content += '</div><!-- content -->';

    $(".wrapper").append(content);
}

(jQuery)(function($) {

    templateHTML();

    // Get main path of users data from server with JSON
    fullData = new GetData(1);
    fullData.marker = {};
});